type identifier = int

let appout = ref stdout;;

module Identifier = struct type t = identifier let compare = compare end 

module Global_Index = Index;;
let global_index = ref FunctionSymbol.index;; 


module String_to_identifier = Map.Make(String)
module Identifier_to_string = Map.Make(Identifier)

(*
let s2id = ref String_to_identifier.empty;;
let id2s = ref Identifier_to_string.empty;;
*)
(*
let s_on_fly2id = ref String_to_identifier.empty;;
let id_on_fly2s = ref Identifier_to_string.empty;;
*)

let identifier_of_string_with_exception s = 
    Global_Index.index_with_exception !global_index s;;

let identifier_of_string s = 
    Global_Index.index !global_index s;;

(*
let identifier_of_string_with_exception s = 
    String_to_identifier.find s !s2id;;

let identifier_of_string s = 
    try
        String_to_identifier.find s !s2id
    with
        Not_found ->
        let id = String_to_identifier.cardinal !s2id in
        begin
            s2id := String_to_identifier.add s id !s2id;
            id2s := Identifier_to_string.add id s !id2s;
            id;
        end;;
*)

let escaped_string_of_identifier id =
(*
    let s = try
                Identifier_to_string.find id !id2s
            with
                Not_found -> failwith "Unknown identifier: "^(string_of_int id)
(*                    try
                        Identifier_to_string.find id !id_on_fly2s            
                    with
                        Not_found -> failwith "Unknown identifier: "^(string_of_int id)
                        *)
*)                        
    let s = try
                Global_Index.element !global_index id
            with
                Not_found -> failwith "Unknown identifier: "^(string_of_int id)
    in
    let contains = String.contains in
    let contains_brackets s =       (contains s '(')  || (contains s ')') in 
    let contains_whitespaces s =    (contains s '\"') || 
                                    (contains s ' ')  || 
                                    (contains s '\t') || 
                                    (contains s '\n') 
    in
    if (contains_whitespaces s) || (contains_brackets s)
    then "\"" ^ (String.escaped s) ^ "\""
    else s;;

let quoted_string_of_identifier id =
(*
    let s = try
                Identifier_to_string.find id !id2s
            with
                Not_found -> failwith "Unknown identifier: "^(string_of_int id)
(*                    try
                        Identifier_to_string.find id !id_on_fly2s            
                    with
                        Not_found -> failwith "Unknown identifier: "^(string_of_int id)
                        *)
*)                        
    let s = try
                Global_Index.element !global_index id
            with
                Not_found -> failwith "Unknown identifier: "^(string_of_int id)
    in
    "\"" ^ (String.escaped s) ^ "\""
;;
    
let string_of_identifier id =
(*
    let s = try
                Identifier_to_string.find id !id2s
            with
                Not_found -> failwith "Unknown identifier: "^(string_of_int id)
(*                    try
                        Identifier_to_string.find id !id_on_fly2s            
                    with
                        Not_found -> failwith "Unknown identifier: "^(string_of_int id)
                        *)
*)                        
    let s = try
                Global_Index.element !global_index id
            with
                Not_found -> failwith "Unknown identifier: "^(string_of_int id)
    in
    s;;


type 'a grammar_tree_type=
    | Nonterminal of 'a * ('a grammar_tree_type list)
    | Terminal of 'a

type ('a,'b) rich_grammar_tree_type=
    | RNT of 'a * ('b ref) * (('a,'b) rich_grammar_tree_type list)
    | RT of 'a * ('b ref)

